package com.tzz;

import java.util.concurrent.TimeUnit;
import java.util.concurrent.atomic.AtomicReference;

/**
 * @author : tangzhaozhen
 * @createTime : 2023/10/28 16:47
 */

public class LockDemo {

    AtomicReference<Thread> atomicReference= new AtomicReference<>();

    public void lock(){
        Thread thread = Thread.currentThread();
        //第一个参数为期望值 第二个为自己
        System.out.println(Thread.currentThread().getName()+"\t"+"----come  in");
        while (!atomicReference.compareAndSet(null,thread)){

        }
    }

    public void unLock(){
        Thread thread = Thread.currentThread();
        atomicReference.compareAndSet(thread,null);
        System.out.println(Thread.currentThread().getName()+"\t"+"-----task over,unlock");
    }



    public static void main(String[] args) {
        LockDemo lockDemo = new LockDemo();

        new Thread(()->{
            lockDemo.lock();
            try {
                //暂停几秒中线程
                TimeUnit.SECONDS.sleep(5);
                lockDemo.unLock();
            } catch (InterruptedException e) {
                throw new RuntimeException(e);
            }
        },"A").start();

        try {
            //暂停500毫秒，线程A先于线程B启动
            TimeUnit.MILLISECONDS.sleep(500);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }

        new Thread(()->{
            lockDemo.lock();
            lockDemo.unLock();
        },"B").start();

    }
}